
#ifndef _MOXA_H


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define CLEAR_FUNC 	cleanup_module
#define CLEAR_FUNC_RET	void
#else
#define CLEAR_FUNC 	moxa_module_exit
#define CLEAR_FUNC_RET	static void __exit
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define INIT_FUNC 	init_module
#define INIT_FUNC_RET	int
#else
#define INIT_FUNC 	moxa_module_init
#define INIT_FUNC_RET	static int __init
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define DRV_VAR		(&moxaDriver)
#define DRV_VAR_P(x)	moxaDriver.x
#else
#define DRV_VAR		(moxaDriver)
#define DRV_VAR_P(x)	moxaDriver->x
#endif

#ifndef INIT_WORK
#define INIT_WORK(_work, _func, _data){	\
	_data->tqueue.routine = _func;\
	_data->tqueue.data = _data;\
	}
#endif

#ifndef set_current_state
#define	set_current_state(x) 		current->state = x
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define IRQ_RET void
#define IRQ_RETVAL(x)
#else
#define IRQ_RET irqreturn_t
#endif


#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#if (LINUX_VERSION_CODE >= VERSION_CODE(2,4,0))
#define	MXQ_TASK() {\
		MOD_INC_USE_COUNT;\
		if (schedule_task(&ch->tqueue) == 0)\
			MOD_DEC_USE_COUNT;\
	}
#else
#define MXQ_TASK()	queue_task(&ch->tqueue,&tq_scheduler)
#endif
#else
#define	MXQ_TASK()	schedule_work(&ch->tqueue)
#endif

#if (LINUX_VERSION_CODE < VERSION_CODE(2,6,0))
#define MX_MOD_INC	MOD_INC_USE_COUNT
#define MX_MOD_DEC	MOD_DEC_USE_COUNT
#else
#define MX_MOD_INC	try_module_get(THIS_MODULE)
#define MX_MOD_DEC	module_put(THIS_MODULE)	
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#ifndef ASYNC_CALLOUT_ACTIVE
#define ASYNC_CALLOUT_ACTIVE 0
#endif
#endif


#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define MX_TTY_DRV(x)	tty->driver->x
#else
#define MX_TTY_DRV(x)	tty->driver.x
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,5))
#if (LINUX_VERSION_CODE > VERSION_CODE(2,6,19))
#define MX_SESSION()	process_session(current)
#else
#define MX_SESSION()	current->signal->session
#endif
#else
#define MX_SESSION()	current->session
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define MX_CGRP()	process_group(current)	
#else
#define MX_CGRP()	current->pgrp	
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define GET_ZPAGE	get_zeroed_page	
#else
#define GET_ZPAGE	get_free_page
#endif

#ifndef atomic_read
#define atomic_read(v)	v
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define MX_ACCESS_CHK(type, addr, size)	access_ok(type, addr, size)	
#else
#define MX_ACCESS_CHK(type, addr, size)	verify_area(type, addr, size)	
#endif

#if (LINUX_VERSION_CODE >= VERSION_CODE(2,6,0))
#define MX_ERR(x)	!(x)	
#else
#define MX_ERR(x)	x	
#endif


#ifndef UCHAR
typedef unsigned char	UCHAR;
#endif


#endif
