
/*****************************************************************************/
/* GLOBAL.H                                                                  */
/*									     */
/* Copyright (c) Moxa Technologies Inc. 1999. All Rights Reserved.	     */
/*									     */
/* Revision history:							     */
/*     8/5/99   Casper                                                       */
/*****************************************************************************/


#ifndef _GLOBAL_H
#define _GLOBAL_H

#define         MAX_BOARDS 		4
#define         MAX_PORTS_PER_BOX       8
#define         MAX_BOX                 4
#define         MAX_PORTS_PER_BOARD     (MAX_PORTS_PER_BOX * MAX_BOX)

#define         MAX_PORT (MAX_BOARDS * MAX_PORTS_PER_BOARD)

#define         MOXA_BUS_TYPE_ISA		0
#define         MOXA_BUS_TYPE_PCI		1

#define		MOXA	0x400
#define	        MOXA_GET_CONF   (MOXA + 35)
#define	        MOXA_GET_MAJOR  (MOXA + 63)
#define	        MOXA_GET_CUMAJOR  (MOXA + 64)

#ifndef		CMSPAR
#define		CMSPAR	010000000000
#endif

#ifndef		B921600
#define		B921600 (B460800 + 1)
#endif


typedef struct	_moxa_pci_devinfo {
	ushort	busNum;
	ushort	devNum;
} moxa_pci_devinfo;

typedef struct _moxa_board_conf {
	int			boardType;
	int			numPorts;
	ulong			baseAddr;
	int			busType;
	moxa_pci_devinfo	pciInfo;
} moxa_board_conf;

enum	{
	MOXA_BOARD_C218_PCI = 1,
	MOXA_BOARD_C218_ISA,
	MOXA_BOARD_C320_PCI,
	MOXA_BOARD_C320_ISA,
	MOXA_BOARD_CP204J,
};

#endif
